#include    <netdb.h>
#include    <signal.h>
#include    <stdio.h>
#include    <stdlib.h>
#include    <time.h>
#include    <netinet/in.h>
#include    <sys/types.h>
#include    <sys/socket.h>
#include    <sys/ioctl.h>
#include    <zlib.h>

#include    "systype.h"

#ifdef      LINUX
#include    <linux/soundcard.h>
#endif

#ifdef      BSD
#include    <soundcard.h>
#endif

#include    "defs.h"

/* k */
int         comp(char*inbuf, int inlen, char*outbuf, int outlen, int level)
{
  z_stream    z;                  /* CuƂƂ肷邽߂̍\ */

  /* ׂẴǗCuɔC */
  z.zalloc = Z_NULL;
  z.zfree  = Z_NULL;
  z.opaque = Z_NULL;

  if(level < 0)
    level = Z_DEFAULT_COMPRESSION;

  /* kCu */
  if(Z_OK != deflateInit(&z, level)) {
    fprintf(stderr, "deflateInit: %s\n", (z.msg) ? z.msg : "???");
    return -1;
  }

  z.next_in   = inbuf;           /* ̓|C^ */
  z.avail_in  = inlen;           /* ̓obt@̃f[^̃oCg */
  z.next_out  = outbuf;          /* o̓|C^ */
  z.avail_out = outlen;          /* o̓obt@̃TCY */

  /* k */
  if (Z_OK != deflate(&z, Z_NO_FLUSH)) {
    fprintf(stderr, "deflate: %s\n", (z.msg) ? z.msg : "???");
    return -1;
  }

  /* o͗pobt@ꂽꍇ, sƂ݂Ȃ */
  if(Z_STREAM_END != deflate(&z, Z_FINISH))
    return -1;

  /* n */
  if (Z_OK != deflateEnd(&z)) {
    fprintf(stderr, "deflateEnd: %s\n", (z.msg) ? z.msg : "???");
    exit(1);
  }

  return outlen - z.avail_out;
}

/* WJ */
int         decomp(char*inbuf, int inlen, char*outbuf, int outlen)
{
  z_stream    z;                  /* CuƂƂ肷邽߂̍\ */

  /* ׂẴǗCuɔC */
  z.zalloc = Z_NULL;
  z.zfree  = Z_NULL;
  z.opaque = Z_NULL;

  /* WJCu */
  if(Z_OK != inflateInit(&z)) {
    fprintf(stderr, "inflateInit: %s\n", (z.msg) ? z.msg : "???");
    return -1;
  }
  z.next_in   = inbuf;           /* ̓|C^ */
  z.avail_in  = inlen;           /* ̓obt@̃f[^̃oCg */
  z.next_out  = outbuf;          /* o̓|C^ */
  z.avail_out = outlen;          /* o̓obt@̃TCY */

  /* WJ */
#if 0
  if (Z_OK != inflate(&z, Z_NO_FLUSH)) {
    fprintf(stderr, "inflate: %s\n", (z.msg) ? z.msg : "???");
    return -1;
  }
#else
  inflate(&z, Z_NO_FLUSH);
#endif

#if 0
  if(Z_STREAM_END != inflate(&z, Z_FINISH)){
    fprintf(stderr, "inflate: %s\n", (z.msg) ? z.msg : "???");
    return -1;
  }
#else
  inflate(&z, Z_FINISH);
#endif


  /* n */
  if (Z_OK != inflateEnd(&z)) {
    fprintf(stderr, "inflateEnd: %s\n", (z.msg) ? z.msg : "???");
    exit(1);
  }

  return outlen - z.avail_out;
}
