#ifndef     __DEFS_H__
#define     __DEFS_H__

#include    <openssl/des.h>

#define     TRUE            1
#define     FALSE           0

#define     PORT_NUM        3210
#define     DEV             "/dev/dsp"
//#define     DEV             "/dev/audio"

#define     FS              11025 /* sampling freq.[Hz] */
//#define     FS              22050 /* sampling freq.[Hz] */
//#define     FS              44100 /* sampling freq.[Hz] */
#define     CH              1     /* channels */
#define     BT              8    /* bits */
#define     DELTA           .005 /* threashold */

#define     CONTROL         1
#define     DUMMY           2
#define     MESSAGE         4
#define     SOUND           8
#define     COMPRESSED      16
#define     ENCRYPTED       32

#define     INT             100  /* interval [mili seconds] */

#define     HED_LEN         1024             /* header length */
#define     MSG_LEN         1024             /* message length */
//#define     SND_LEN         (FS * CH * BT / 8 * INT / 1000) /* sound length */

#define     DES_KEY         {0xcf, 0x34, 0x05, 0x7f, 0x30, 0xf5, 0x95, 0x15}

#define     max(A, B)       ((A) < (B) ? (B) : (A))

typedef     struct{
  int         sys_freq;              /* sampling freq. */
  int         sys_channels;          /* channels */
  int         sys_bits;              /* bits */

  int         freq;                  /* sampling freq. */
  int         channels;              /* channels */
  int         bits;                  /* bits */

  char*       host;
  int         port;
  int         interval;
//  const_des_cblock DES_key;
  unsigned char* DES_key;
  int         chat;
  int         compress;
  int         debug;
  int         server;
}           OPTION;

#endif
