#include    <math.h>
#include    <netdb.h>
#include    <signal.h>
#include    <stdio.h>
#include    <stdlib.h>
#include    <time.h>
#include    <netinet/in.h>
#include    <sys/types.h>
#include    <sys/socket.h>
#include    <sys/ioctl.h>

#include    "systype.h"

#ifdef      LINUX
#include    <linux/soundcard.h>
#endif

#ifdef      BSD
#include    <soundcard.h>
#endif

#include    "defs.h"
#include    "dsp.h"

/* Initialize DSP (mode, channels, sampling_freq, bits) */
FILE*       init_dsp(char*name, char*mode, int ch, int fs, int bt)
{
  FILE*       fp; /* file pointer */
  int         format;     /* եޥå */
  int         fd; /* file discriptor */

  if(8 == bt)
    format = AFMT_S8;
  else
    format = AFMT_S16_LE;

  fp = fopen(name, mode);
  if(NULL == fp){
    fprintf(stderr, "fopen(%s, %s) failure.\n", name, mode);
    exit(EXIT_FAILURE);
  }

  fd = fileno(fp);
  ioctl(fd, SNDCTL_DSP_SETFMT, &format);
  ioctl(fd, SNDCTL_DSP_CHANNELS, &ch);
  ioctl(fd, SNDCTL_DSP_SPEED, &fs);

  return fp;
}

void         input(FILE*fp, int*left, int*right, OPTION*opt)
{
  int          i, j;
  int          ratio;
  int          threshold = (int)(DELTA * 32767);  /* 0ȸʤ */

  ratio = opt->sys_freq / opt->freq;

  *left = *right = 0;
  for(i = 0; i < ratio; i++){
    /* ͥ뤫 */
    j  = fgetc(fp);
    j |= (char)fgetc(fp) << 8;
    *left += j;

    /* ͥ뤫 */
    j  = fgetc(fp);
    j |= (char)fgetc(fp) << 8;
    *right += j;
  }
  *left  /= ratio;
  *right /= ratio;

  /* ͤͤ꾮0ȸʤ */
  if(abs(*left)  < threshold)
    *left  = 0;
  if(abs(*right) < threshold)
    *right = 0;

  /* ΥʤкʿѤ׻ */
  if(1 == opt->channels){
    *left += *right;
    *left /= 2;
    *right = *left;
  }

  /* ӥåȿ8ʤ, 256ǳ */
  if(16 == opt->sys_bits && 8 == opt->bits){
    *left  /= 256;
    *right /= 256;
  }
}

void        input_buf(FILE*fp, char*buf, int size, OPTION*opt)
{
  int         i = 0;
  int         left, right;

  while(i < size){
    input(fp, &left, &right, opt);

    buf[i++] =  left         & 0xff;
    if(16 == opt->bits)
      buf[i++] = (left   >> 8) & 0xff;

    if(2 == opt->channels){
      buf[i++] =  right        & 0xff;
      if(16 == opt->bits)
        buf[i++] = (right  >> 8) & 0xff;
    }
  }
}

void output(FILE*fp, int left, int right, OPTION*opt)
{
  int          i;
  int          ratio;

  /* ӥåȿ8ʤ, 256ݤ */
  if(16 == opt->sys_bits && 8 == opt->bits){
    left  *= 256;
    right *= 256;
  }

//  ratio = opt->sys_freq / opt->freq;
  ratio = 1;

  for(i = 0; i < ratio; i++){
    /* ͥ */
    fputc( left        & 0xff, fp);
    fputc((left  >> 8) & 0xff, fp);

    /* ͥ */
    fputc( right       & 0xff, fp);
    fputc((right >> 8) & 0xff, fp);
  }
}

void        output_buf(FILE*fp, char*buf, int size, OPTION*opt)
{
  int         i = 0;
  int         left, right;

  while(i < size){
    left   = buf[i++] & 0xff;
    if(16 == opt->bits)
      left  |= buf[i++] << 8;

    if(2 == opt->channels){
      right  = buf[i++] & 0xff;
      if(16 == opt->bits)
        right |= buf[i++] << 8;
    }else
      right = left;

    output(fp, left, right, opt);
  }
}
