#include    <netdb.h>
#include    <signal.h>
#include    <stdio.h>
#include    <stdlib.h>
#include    <time.h>
#include    <netinet/in.h>
#include    <sys/types.h>
#include    <sys/socket.h>
#include    <sys/ioctl.h>

#include    "systype.h"

#ifdef      LINUX
#include    <linux/soundcard.h>
#endif

#ifdef      BSD
#include    <soundcard.h>
#endif

#include    "defs.h"
#include    "sock_rw.h"
#include    "dsp.h"
#include    "communicate.h"
#include    "option.h"

#define     IP_LEN (4 * 4)

int         hostname2ip(char*name, char*addr)
{
  struct hostent*host_info;

  host_info = gethostbyname(name);
  if(host_info == NULL){
    perror("gethostbyname");
    return -1;
  }

  snprintf(addr, IP_LEN, "%d.%d.%d.%d",
           (unsigned char)host_info->h_addr_list[0][0],
           (unsigned char)host_info->h_addr_list[0][1],
           (unsigned char)host_info->h_addr_list[0][2],
           (unsigned char)host_info->h_addr_list[0][3]);

  return 0;
}

int         server_main(OPTION*opt)
{
  int sockfd, newsockfd;
  int clilen;
  struct sockaddr_in srv_addr, cli_addr;

  /* open TCP socket */
  if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0){
    fprintf(stderr, "socket() failure.\n");
    return EXIT_FAILURE;
  }

  /* bind local addr. */
  bzero((char*)&srv_addr, sizeof(srv_addr));
  srv_addr.sin_family = AF_INET;
  srv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  srv_addr.sin_port = htons(PORT_NUM);

  if(bind(sockfd, (struct sockaddr*)&srv_addr, sizeof(srv_addr)) < 0){
    fprintf(stderr, "bind() failure.\n");
    return EXIT_FAILURE;
  }

  listen(sockfd, 5);

    clilen = sizeof(cli_addr);
    if((newsockfd = accept(sockfd, (struct sockaddr*)&cli_addr, &clilen)) < 0){
      fprintf(stderr, "accept() failure.\n");
      return EXIT_FAILURE;
    }

  printf("Here comes a client.\n");

    phone(newsockfd, opt);
    close(newsockfd);

  close(sockfd);

  return EXIT_SUCCESS;
}

int         client_main(OPTION*opt)
{
  int         sockfd;
  struct sockaddr_in srv_addr;
  char        ip_addr[IP_LEN];
  struct hostent*host_info;

  /* set server addr. */
  bzero((char*)&srv_addr, sizeof(srv_addr));
  srv_addr.sin_family = AF_INET;

  /* O */
  host_info = gethostbyname(opt->host);
  if(host_info == NULL){
    perror("gethostbyname");
    return -1;
  }
  bcopy(host_info->h_addr, (char*)&srv_addr.sin_addr, host_info->h_length);

  srv_addr.sin_port = htons(PORT_NUM);

  /* open TCP socket */
  if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0){
    fprintf(stderr, "socket() failure.\n");
    return EXIT_FAILURE;
  }

  /* connect to server */
  if(connect(sockfd, (struct sockaddr*)&srv_addr, sizeof(srv_addr)) < 0){
    fprintf(stderr, "connect() failure.\n");
    return EXIT_FAILURE;
  }

  puts("Connected to server successfully.");

  phone(sockfd, opt);

  close(sockfd);

  return EXIT_SUCCESS;
}

int         main(int argc, char*argv[])
{
  OPTION      opt;

  if(argc < 2){
    fprintf(stderr, "usage: %s IP/option\n", argv[0]);
    return EXIT_FAILURE;
  }

  if(analize_options(argc, argv, &opt))
    return EXIT_FAILURE;

  if(opt.debug)
    print_options(stderr, &opt);

  if(verify_option(&opt) < 0)
    return EXIT_FAILURE;

  if(opt.server)
    return server_main(&opt); /* server mode */
  else
    return client_main(&opt); /* client mode */
}
