#include    <stdio.h>
#include    <stdlib.h>

#include    "defs.h"

int         analize_options(int argc, char**argv, OPTION*opt)
{
  int         i, j;

  /* set default values */
  opt->sys_freq  = 44100;
  opt->sys_channels = 2;
  opt->sys_bits  = 16;
  opt->freq     = FS;                  /* sampling freq. */
  opt->channels = CH;                  /* channels */
  opt->bits     = BT;                  /* bits */
  opt->host     = NULL;
  opt->port     = PORT_NUM;
  opt->interval = INT;
  opt->DES_key  = NULL;
  opt->chat     = 0;
  opt->compress = 6;
  opt->debug    = 0;
  opt->server    = 0;

  i = 1;
  while(i < argc){
    if('-' == argv[i][0]){
      /* --option */
      if(0 == strcmp(argv[i], "-M") || 0 == strcmp(argv[i], "--monoral"))
        opt->channels = 1;
      else

      if(0 == strcmp(argv[i], "-S") || 0 == strcmp(argv[i], "--stereo" ))
        opt->channels = 2;
      else

      if(0 == strcmp(argv[i], "-c") || 0 == strcmp(argv[i], "--chat" ))
        opt->chat = TRUE;
      else

      if(0 == strcmp(argv[i], "-d") || 0 == strcmp(argv[i], "--debug" ))
        opt->debug = 1;
      else

      if(0 == strcmp(argv[i], "-s") || 0 == strcmp(argv[i], "--server" ))
        opt->server = 1;
      else

      /* --option VALUE */
      if(0 == strcmp(argv[i], "-f") || 0 == strcmp(argv[i], "--sample" )){
        i++;
        opt->freq = atoi(argv[i]);
      }else

      if(0 == strcmp(argv[i], "-b") || 0 == strcmp(argv[i], "--bits"   )){
        i++;
        opt->bits = atoi(argv[i]);
      }else

      if(0 == strcmp(argv[i], "-i") || 0 == strcmp(argv[i], "--interval")){
        i++;
        opt->interval = atoi(argv[i]);
      }else

      if(0 == strcmp(argv[i], "-p") || 0 == strcmp(argv[i], "--port")){
        i++;
        opt->port = atoi(argv[i]);
      }else

      if(0 == strcmp(argv[i], "-C") || 0 == strcmp(argv[i], "--encrypt")){
        i++;
        opt->DES_key = malloc(sizeof(unsigned char) * 8);
        for(j = 0; j < 8; j++){
          opt->DES_key[i]  = (unsigned char)argv[i][j    ] * 16;
          opt->DES_key[i] += (unsigned char)argv[i][j + 1];
        }
      }else

      /* --option [VALUE] */
      if(0 == strcmp(argv[i], "-z") || 0 == strcmp(argv[i], "--compress")){
        if('-' != argv[i + 1][0]){
          i++;
          opt->compress = atoi(argv[i]);
        }
      }
//      if(0 == strcmp(argv[i], "") || 0 == strcmp(argv[i], ""))
    }else{
      opt->host = malloc(sizeof(char) * strlen(argv[i]));
      if(NULL == opt->host){
        fprintf(stderr, "malloc() failure.\n");
        return -1;
      }
      strcpy(opt->host, argv[i]);
    }
    i++;
  }

  return 0;
}

void        print_options(FILE*fp, OPTION*opt)
{
  fprintf(fp, "freq     : %d\n", opt->freq);
  fprintf(fp, "channels : %d\n", opt->channels);
  fprintf(fp, "bits     : %d\n", opt->bits);
  fprintf(fp, "host     : %s\n", opt->host);
  fprintf(fp, "port     : %d\n", opt->port);
  fprintf(fp, "interval : %d\n", opt->interval);
  fprintf(fp, "DES_key  : \n", opt->DES_key);
  fprintf(fp, "chat     : %d\n", opt->chat);
  fprintf(fp, "compress : %d\n", opt->compress);
  fprintf(fp, "debug    : %d\n", opt->debug);
  fprintf(fp, "server   : %d\n", opt->server);
}

int        verify_option(OPTION*opt)
{
  return 0;
}
