#include    <math.h>
#include    <netdb.h>
#include    <signal.h>
#include    <stdio.h>
#include    <stdlib.h>
#include    <time.h>
#include    <netinet/in.h>
#include    <sys/types.h>
#include    <sys/socket.h>
#include    <sys/ioctl.h>

#include    "../systype.h"

#ifdef      LINUX
#include    <linux/soundcard.h>
#endif

#ifdef      BSD
#include    <soundcard.h>
#endif

#include    "defs.h"
#include    "dsp.h"

/* Initialize DSP (mode, channels, sampling_freq, bits) */
FILE*       init_dsp(char*name, char*mode, int ch, int fs, int bt)
{
  FILE*       fp; /* file pointer */
  int         format;     /* եޥå */
  int         fd; /* file discriptor */

  if(8 == bt)
    format = AFMT_S8;
  else
    format = AFMT_S16_LE;

  fp = fopen(name, mode);
  if(NULL == fp){
    fprintf(stderr, "fopen(%s, %s) failure.\n", name, mode);
    exit(EXIT_FAILURE);
  }

  fd = fileno(fp);
  ioctl(fd, SNDCTL_DSP_SETFMT, &format);
  ioctl(fd, SNDCTL_DSP_CHANNELS, &ch);
  ioctl(fd, SNDCTL_DSP_SPEED, &fs);

  return fp;
}

void         input(FILE*fp, int*left, int*right, int ch, int bt)
{
  /* ͥ뤫 */
  *left   = fgetc(fp);
  if(16 == bt)
    *left  |= (char)fgetc(fp) << 8;

  if(2 == ch){
    /* ͥ뤫 */
    *right  = fgetc(fp);
    if(16 == bt)
      *right |= (char)fgetc(fp) << 8;
  }else
    *right = *left;
}

void        input_buf(FILE*fp, char*buf, int size, int ch, int bt)
{
  int         i = 0;
  int         left, right;

  while(i < size){
    input(fp, &left, &right, ch, bt);

    buf[i++] =  left         & 0xff;
    if(16 == bt)
      buf[i++] = (left   >> 8) & 0xff;

    if(2 == ch){
      buf[i++] =  right        & 0xff;
      if(16 == bt)
        buf[i++] = (right  >> 8) & 0xff;
    }
  }
}

void output(FILE*fp, int left, int right, int ch, int bt)
{
  /* ΥʤкʿѤ׻ */
  if(1 == ch)
    left = (left + right) / 2;

  /* ͥ */
  fputc( left        & 0xff, fp);
  if(16 == bt)
    fputc((left  >> 8) & 0xff, fp);

  /* ͥ */
  if(2 == ch){
    fputc( right       & 0xff, fp);
    if(16 == bt)
      fputc((right >> 8) & 0xff, fp);
  }
}

void        output_buf(FILE*fp, char*buf, int size, int ch, int bt)
{
  int         i = 0;
  int         left, right;

  while(i < size){
    left   = buf[i++] & 0xff;
    if(16 == bt)
      left  |= buf[i++] << 8;

    if(2 == ch){
      right  = buf[i++] & 0xff;
      if(16 == bt)
        right |= buf[i++] << 8;
    }else
      right = left;

    output(fp, left, right, ch, bt);
  }
}
